'use strict';

import defaultOption from './core/lib/default_option';
import render from './core/render';

let route = { };

const loader = { };

loader.route = function ( path, option ) {
    if ( arguments.length == 1 && !option ) {
        option = path;
        path = void 0;
    }

    const opt = Object.assign( JSON.parse( JSON.stringify( defaultOption ) ), option, {
        loading: document.querySelector( '#page-loading' ),
        el: document.querySelector( '#page-template' ),
    } );

    path ? route[ path ] = opt : route[ 'default' ] = opt;
};

loader.render = ( ) => {
    const pathname = location.pathname;

    let routeName = void 0;

    for ( let item in route ) {
        if ( item.indexOf( '/**' ) > 0 ) {
            const _item = item.split('/**')[ 0 ];

            if ( pathname.indexOf( _item ) == 0 ) {
                routeName = item;
            }
        }
        else if ( item == pathname ) {
            routeName = item;
        }
    }

    const option = route[ routeName ] || route[ 'default' ] || { };

    render( option );
}

module.exports = loader;
